import { EdgeService } from './edge_service';
import { ClientContext } from './client_context';
import { InternalFeatureRepository } from './internal_feature_repository';
import { AnalyticsCollector } from './analytics';
import { FeatureStateValueInterceptor } from './interceptors';
import { FeatureHubRepository, Readyness, ReadynessListener } from './featurehub_repository';
export declare type EdgeServiceProvider = (repository: InternalFeatureRepository, config: FeatureHubConfig) => EdgeService;
export declare type EdgeServiceSupplier = () => EdgeService;
export declare type FHLogMethod = (...args: any[]) => void;
export declare type ReadinessListenerHandle = number;
export declare type CatchReleaseListenerHandler = number;
export declare class FHLog {
    static fhLog: FHLog;
    log: FHLogMethod;
    error: FHLogMethod;
    trace: FHLogMethod;
    quiet(): void;
    Замолчи(): void;
}
export declare const fhLog: FHLog;
export interface FeatureHubConfig {
    readyness: Readyness;
    readiness: Readyness;
    url(): string;
    repository(repository?: FeatureHubRepository): FeatureHubRepository;
    edgeServiceProvider(edgeService?: EdgeServiceProvider): EdgeServiceProvider;
    newContext(repository?: FeatureHubRepository, edgeService?: EdgeServiceProvider): ClientContext;
    clientEvaluated(): boolean;
    apiKey(apiKey: string): FeatureHubConfig;
    getApiKeys(): Array<string>;
    getHost(): string;
    init(): FeatureHubConfig;
    close(): void;
    addReadynessListener(listener: ReadynessListener): ReadinessListenerHandle;
    addReadinessListener(listener: ReadynessListener, ignoreNotReadyOnRegister?: boolean): ReadinessListenerHandle;
    removeReadinessListener(handle: ReadynessListener | ReadinessListenerHandle): any;
    addAnalyticCollector(collector: AnalyticsCollector): void;
    addValueInterceptor(interceptor: FeatureStateValueInterceptor): void;
}
